-- Local initialisations
Nanika = LibStub("AceAddon-3.0"):NewAddon("Nanika", "AceEvent-3.0", "AceTimer-3.0")
local settings = {}

-- Ace functions
function Nanika:OnInitialize()
	local dbsettings = { profile = settings }
	self.db = LibStub("AceDB-3.0"):New("NanikaDB", dbsettings, true)
	settings = self.db.profile
	--Set up configuration screen
	--Set up slash commands
end
function Nanika:OnEnable()
end
function Nanika:OnDisable()
end
-- Chat helpers
function Nanika:SW(msg)
	--SendChatMessage(msg, "WHISPER", nil, UnitName("player"))
	print(msg)
end
function Nanika:PC(msg)
	print("Party chat: "..msg)
	if IsInGroup(LE_PARTY_CATEGORY_HOME) then SendChatMessage(msg, "PARTY") return end
	self:SW(msg)
end
function Nanika:GC(msg)
	print("Group chat: "..msg)
	if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then SendChatMessage(msg, "INSTANCE_CHAT") return end
	self:PC(msg)
end
function Nanika:RC(msg)
	print("Raid chat: "..msg)
	if IsInRaid() then SendChatMessage(msg, "RAID") return end
	self:GC(msg)
end
function Nanika:RW(msg)
	print("Raid warning: "..msg)
	if UnitIsRaidOfficer("player") then SendChatMessage(msg ,"RAID_WARNING") return end
	self:RC(msg)
end
-- Player helpers
function Nanika:GetClass()
	local _, class = UnitClass("player")
	return class
end
-- Group/Raid helpers
function Nanika:GetRaidLayout()
	if not IsInGroup() then return nil end
	local raid = {}
	for i = 1, MAX_RAID_GROUPS do raid[i] = { MemberCount = 0, Members = {} } end
	if IsInRaid() then
		for i = 1, GetNumGroupMembers() do
			name,_,subgroup = GetRaidRosterInfo(i)
			raid[subgroup].MemberCount = raid[subgroup].MemberCount + 1
			table.insert(raid[subgroup].Members, { Name = name, UnitId = "raid"..i })
		end
	else
		raid[1].MemberCount = GetNumGroupMembers()
		--table.insert(raid[1].Members, { Name = UnitName("player"), UnitId = "player" })
		for i = 1, raid[1].MemberCount do
			name = GetRaidRosterInfo(i)
			table.insert(raid[1].Members, { Name = name, UnitId = "party"..i })
		end
	end
	return raid
end
